=== modified file 'NEWS'
--- NEWS	2008-03-06 01:59:26 +0000
+++ NEWS	2008-06-22 23:47:59 +0000
@@ -1,6 +1,48 @@
 What's changed in loggerhead?
 =============================
 
+1.6 [unreleased]
+----------------
+
+    - Loggerhead is no longer a TurboGears application, but rather a
+      WSGI application built using Paste (see http://wsgi.org/ and
+      http://pythonpaste.org/ for more about WSGI and Paste). XXX more.
+
+    - zpt.cleaner_urls bug 138021 ("loggerhead should generate links
+      based on revision numbers and file paths").  XXX more.
+
+    - The scripts no longer insist on Python 2.4 -- loggerhead works
+      fine with 2.5.
+
+    - Bazaar as of version 1.5 has improved in performance enough that
+      the revision cache no longer gave any noticeable benefit, so it
+      was removed (the files-changed cache is still useful).
+
+    - The templates were rewritten in Zope's TAL markup, powered by
+      the simpleTAL library -- improving both the performance and
+      memory consumption of rendering by a factor of around 3 for
+      large pages over the old Kid templates.
+
+    - Loggerhead's poorly performing text index was disabled.
+
+    - Loggerhead no longer depends on bzrlib functions deprecated in
+      Bazaar 1.5 and removed in 1.6 (Martin Albisetti).
+
+    - The daemonization code was made more regular, fixing bugs
+      #139161 ("Starting loggerhead process may not close its stdin
+      and stdout properly") and #211526 ("Codebrowse log directory has
+      unnecessarily permissive permissions")
+
+    - Some confusion about what the 'file_id' query argument means was
+      cleared up: filter_file_id now means "filter revisions to those
+      that affect this file" in all views and file_id means "examine
+      this file/directory" in the annotate and inventory views.
+
+    - Dates are present more compactly.
+
+    - The loggerhead.conf file can specify which network interface to
+      bind to (Mattias Eriksson)
+
 1.2.1  [06mar2008]
 ------------------
 

=== modified file 'README.txt'
--- README.txt	2008-06-16 09:48:20 +0000
+++ README.txt	2008-06-23 02:37:05 +0000
@@ -1,29 +1,69 @@
 LOGGERHEAD
 ==========
 
-[ Version 1.2 for Bazaar 1.2 ]
+[ Version 1.6 for Bazaar 1.6 ]
 
 Loggerhead is a web viewer for Bazaar branches.  It can be used to
 navigate a branch history, annotate files, perform searches... all the
 usual things.
 
-To get started, first you need to create a 'loggerhead.conf' file
-specifying the branches you want to view.  A 'loggerhead.conf.example'
-file is included in the source which has comments explaining the
-various options.
+
+GETTING STARTED
+---------------
+
+Loggerhead depends on SimpleTAL for templating and Paste for the
+server.  So you need these installed -- on Ubuntu you want the
+'python-simpletal' and 'python-paste' packages installed.  You need
+version 1.2 or newer of Paste.
+
+Then simply run the 'serve-branches.py' with the branch you want to
+serve on the command line:
+
+    ./serve-branches.py ~/path/to/branch
+
+The script listens on port 8080 so head to http://localhost:8080/ in
+your browser to see the branch.  You can also pass a directory that
+contains branches to the script, and it will serve a very simple
+directory listing at other pages.
+
+You may update the Bazaar branches being viewed at any time.
+Loggerhead will notice and refresh, and Bazaar uses its own branch
+locking to prevent corruption.
+
+
+USING A CONFIG FILE
+-------------------
+
+Previous versions of Loggerhead read their configuration from a config
+file.  This mode of operation is still supported by the
+'start-loggerhead.py' script.  A 'loggerhead.conf.example' file is
+included in the source which has comments explaining the various
+options.
 
 Loggerhead can then be started by running::
 
     $ ./start-loggerhead.py
 
-This will run loggerhead in the background.  It listens on port 8080
-by default, so go to http://localhost:8080/ in your browser to see the
-list of bublished branches.
+This will run loggerhead in the background, listening on port 8080 by
+default.
 
 To stop Loggerhead, run::
 
     $ ./stop-loggerhead.py
 
+In the configuration file you can configure projects, and branches per
+project.  The idea is that you could be publishing several (possibly
+unrelated) projects through the same loggerhead instance, and several
+branches for the same project.  See the "loggerhead.conf.example" file
+included with the source.
+
+A debug and access log are stored in the logs/ folder, relative to
+the location of the start-loggerhead.py script.
+
+
+SERVING LOGGERHEAD FROM BEHIND APACHE
+-------------------------------------
+
 If you want to view Bazaar branches from your existing Apache
 installation, you'll need to configure Apache to proxy certain
 requests to Loggerhead.  Adding lines like this to you Apache
@@ -34,22 +74,11 @@
         ProxyPassReverse http://127.0.0.1:8080/
     </Location>
 
-In the configuration file you can configure projects, and branches per
-project.  The idea is that you could be publishing several (possibly
-unrelated) projects through the same loggerhead instance, and several
-branches for the same project.  See the "loggerhead.conf.example" file
-included with the source.
-
-Although Loggerhead is a TurboGears (http://www.turbogears.org)
-project, don't bother with "dev.cfg" or any of the other TurboGears
-config files.  Loggerhead overrides those values with its own.
-
-A debug and access log are stored in the logs/ folder, relative to
-the location of the start-loggerhead.py script.
-
-You may update the Bazaar branch at any time (for example, from a cron).
-Loggerhead will notice and refresh, and Bazaar uses its own branch
-locking to prevent corruption.
+If Paste Deploy is installed, the 'serve-branches.py' script can be
+run behind a proxy at the root of a site, but if you're running it at
+some path into the site, you'll need to add a 'prefix' argument to the
+PrefixMiddleware call in the script.  More flexible configuration
+should be added soon...
 
 
 FILES CHANGED CACHE
@@ -70,3 +99,6 @@
 subscribe to post, but your first post will be held briefly for manual
 moderation.
 
+Bugs are tracked on Launchpad; start at:
+
+    https://bugs.launchpad.net/loggerhead

=== removed file 'loggerhead/branchview.py'
--- loggerhead/branchview.py	2008-06-16 09:26:05 +0000
+++ loggerhead/branchview.py	1970-01-01 00:00:00 +0000
@@ -1,161 +0,0 @@
-#
-# Copyright (C) 2006  Robey Pointer <robey@lag.net>
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-#
-
-"""
-collection of configuration and objects related to a bazaar branch.
-"""
-
-import logging
-import posixpath
-import threading
-import urllib
-
-import turbogears
-from cherrypy import HTTPRedirect
-
-from loggerhead import util
-from loggerhead.changecache import FileChangeCache
-from loggerhead.history import History
-from loggerhead.controllers.changelog_ui import ChangeLogUI
-from loggerhead.controllers.atom_ui import AtomUI
-from loggerhead.controllers.revision_ui import RevisionUI
-from loggerhead.controllers.inventory_ui import InventoryUI
-from loggerhead.controllers.annotate_ui import AnnotateUI
-from loggerhead.controllers.download_ui import DownloadUI
-from loggerhead.controllers.bundle_ui import BundleUI
-
-
-with_history_lock = util.with_lock('_history_lock', 'History')
-
-
-class BranchView (object):
-    def __init__(self, group_name, name, subfolder, absfolder, config,
-                 project_config, root_config):
-        self._group_name = group_name
-        self._name = name
-        self._folder = subfolder
-        self._absfolder = absfolder
-        self._config = config
-        self._project_config = project_config
-        self._root_config = root_config
-        self.log = logging.getLogger('loggerhead.%s' % (name,))
-
-        # branch history
-        self._history_lock = threading.RLock()
-        self._history = None
-
-        self.changes = ChangeLogUI(self)
-        self.revision = RevisionUI(self)
-        self.files = InventoryUI(self)
-        self.annotate = AnnotateUI(self)
-        self.download = DownloadUI(self)
-        self.atom = AtomUI(self)
-        self.bundle = BundleUI(self)
-
-        # force history object to be loaded:
-        self.get_history()
-
-    config = property(lambda self: self._config)
-
-    name = property(lambda self: self._name)
-
-    group_name = property(lambda self: self._group_name)
-
-    def _get_friendly_name(self):
-        name = self._config.get('branch_name', None)
-        if name is not None:
-            return name
-        # try branch-specific config?
-        name = self.get_history().get_config().get_nickname()
-        if name is not None:
-            return name
-        return self._name
-
-    friendly_name = property(_get_friendly_name)
-
-    def _get_description(self):
-        description = self._config.get('description', None)
-        if description is not None:
-            return description
-        # try branch-specific config?
-        description = self.get_history().get_config().get_user_option('description')
-        return description
-
-    description = property(_get_description)
-
-    def _get_branch_url(self):
-        url = self._config.get('url', None)
-        if url is not None:
-            return url
-        # try to assemble one from the project, if an url_prefix was defined.
-        url = self._project_config.get('url_prefix', None)
-        if url is not None:
-            return posixpath.join(url, self._folder) + '/'
-        # try branch-specific config?
-        url = self.get_history().get_config().get_user_option('public_branch')
-        return url
-
-    branch_url = property(_get_branch_url)
-
-    @turbogears.expose()
-    def index(self):
-        raise HTTPRedirect(self.url('/changes'))
-
-    def get_config_item(self, item, default=None):
-        for conf in self._config, self._project_config, self._root_config:
-            if item in conf:
-                return conf[item]
-        return default
-
-    @with_history_lock
-    def get_history(self):
-        """
-        get an up-to-date History object, safely.  each page-view calls this
-        method, and normally it will get the same History object as on previous
-        calls.  but if the bazaar branch on-disk has been updated since this
-        History was created, a new object will be created and returned.
-        """
-        if (self._history is None) or self._history.out_of_date():
-            self.log.debug('Reload branch history...')
-            _history = self._history = History.from_folder(
-                self._absfolder, self._name)
-            cache_path = self._config.get('cachepath', None)
-            if cache_path is None:
-                # try the project config
-                cache_path = self._project_config.get('cachepath', None)
-            if cache_path is not None:
-                _history.use_file_cache(FileChangeCache(_history, cache_path))
-        return self._history
-
-    def url(self, elements, **kw):
-        "build an url relative to this branch"
-        if not isinstance(elements, list):
-            elements = [elements]
-        if elements[0].startswith('/'):
-            elements[0] = elements[0][1:]
-        elements = [urllib.quote(x) for x in elements]
-        return turbogears.url([ '/' + self.group_name, self.name ] + elements, **kw)
-
-    def context_url(self, elements, **kw):
-        "build an url relative to this branch, bringing along browsing context"
-        return self.url(elements, **util.get_context(**kw))
-
-    def last_updated(self):
-        h = self.get_history()
-        change = h.get_changes([ h.last_revid ])[0]
-        return change.date

=== modified file 'serve-branches.py'
--- serve-branches.py	2008-06-22 23:53:25 +0000
+++ serve-branches.py	2008-06-23 02:23:46 +0000
@@ -1,16 +1,30 @@
 #!/usr/bin/env python
+import sys
+
+from paste import httpserver
+from paste.httpexceptions import HTTPExceptionHandler
+from paste.translogger import TransLogger
+
 from loggerhead.apps.filesystem import BranchesFromFileSystemRoot
-from paste import httpserver
-from paste.httpexceptions import make_middleware
-from paste.translogger import make_filter
-
-app = BranchesFromFileSystemRoot('.')
-
-app = app
-app = make_middleware(app)
-app = make_filter(app, None)
+
+if len(sys.argv) > 1:
+    path = sys.argv[1]
+else:
+    path = '.'
+
+app = BranchesFromFileSystemRoot(path)
+
+app = HTTPExceptionHandler(app)
+app = TransLogger(app)
+
+try:
+    from paste.deploy.config import PrefixMiddleware
+except ImportError:
+    pass
+else:
+    app = PrefixMiddleware(app)
 
 #from paste.evalexception import EvalException
 #app = EvalException(app)
 
-httpserver.serve(app, host='0.0.0.0', port='9876')
+httpserver.serve(app, host='0.0.0.0', port='8080')

